/**
 * @fileoverview Every dangerouslySetInnerHTML must be called its security method
 * @author Kathiresan
 */
'use strict';

const DANGEROUS_MESSAGE =
  'Every dangerouslySetInnerHTML must be called its security method';

module.exports = {
  meta: {
    docs: {
      description:
        'Every dangerouslySetInnerHTML must be called its security method',
      category: 'Security Mistakes',
      recommended: false
    },
    fixable: null,
    schema: []
  },

  create: function(context) {
    return {
      JSXAttribute: function(node) {
        if (node.name.name !== 'dangerouslySetInnerHTML') {
          return;
        }
        if (node.value.expression.properties[0].value.type === 'Identifier') {
          context.report({
            node: node,
            message: DANGEROUS_MESSAGE
          });
        }
      }
    };
  }
};
